<!-- 证书监控 -->
<script lang="ts" setup name="CertificationMonitor">
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { certificateMonitorsById } from '@/api/business/schedule/task'
const props = defineProps({
  // 样品id
  sampleId: {
    type: String,
    required: true,
    default: '',
  },
  // 客户id
  customerId: {
    type: String,
    required: true,
    default: '',
  },
})

// 查询条件
const searchQuery = ref({
  sampleId: props.sampleId,
  customerId: props.customerId,
  limit: 10,
  offset: 1,
})
// 表格表头
const columns = ref<TableColumn[]>([
  { text: '证书编号', value: 'certificationReportCode', align: 'center', width: '160' },
  { text: '证书名称', value: 'certificationReportName', align: 'center' },
  { text: '证书类型', value: 'certificationReportCategoryName', align: 'center' },
  { text: '证书状态', value: 'certificationState', align: 'center' },
  { text: '初次提交审核时间', value: 'text', align: 'center', width: '180' },
  { text: '完成时间', value: 'text', align: 'center', width: '180' },
  { text: '退回次数', value: 'text', align: 'center' },
  { text: '制作人', value: 'text', align: 'center' },
])

// 应出具证书数
const requireCertifications = ref(0)
// 当前证书数
const currentCertifications = ref(0)
// 证书列表
const list = ref([])
const total = ref(0)
// 加载状态
const loading = ref(false)
// 查找证书状态及列表
function fetchData(isNowPage = false) {
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    searchQuery.value.offset = 1
  }
  loading.value = true
  list.value = []
  console.log('99999999', searchQuery.value, props.sampleId, props.customerId)
  searchQuery.value.customerId = props.customerId
  searchQuery.value.sampleId = props.sampleId
  certificateMonitorsById({ ...searchQuery.value }).then((res) => {
    list.value = res.data.rows
    total.value = parseInt(res.data.total)
  })
  loading.value = false
}
watch(() => props.sampleId, () => {
  if (props.sampleId && props.customerId) {
    fetchData()
  }
})
watch(() => props.customerId, () => {
  if (props.sampleId && props.customerId) {
    fetchData()
  }
})

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.value.limit = val.size
  }
  if (val && val.page) {
    searchQuery.value.offset = val.page
  }
  fetchData(true)
}
onMounted(() => {
  if (props.sampleId && props.customerId) {
    fetchData()
  }
})
</script>

<template>
  <div>
    <normal-table
      :data="list"
      :total="total"
      :query="searchQuery"
      :columns="columns"
      :list-loading="loading"
      :pagination="true"
      :page-sizes="[10, 20, 30]"
      @change="changePage"
    >
      <template #preColumns>
        <el-table-column label="序号" width="55" align="center">
          <template #default="scope">
            {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
          </template>
        </el-table-column>
      </template>
    </normal-table>
  </div>
</template>
